library ieee;
use ieee.std_logic_1164.all;

-- Strukturbeschreibung (Blockschaltbild)

entity top is
	port
	(
		x0, x1, x2: in bit;
		y: out bit
	);
end;

architecture mfm of top is
	signal t1: bit; 	-- Verbindungssignal zwischen Block 1 und Block 2
begin

-- Hier werden andere Module eingebunden.
-- Der Fachbegriff dafr ist "instanziiert".
-- Jede Instanz bentigt einen eindeutigen Instanznamen.
-- Seit VHDL93 knnen Module direkt (ohne ein package) instanziiert werden.
-- Dann muss man allerdings das Schlsselwort "entity" voranstellen.
-- Das Werkzeug sucht sich die aufgerufenen Blcke (hier: und, oder) selber.
-- Dazu verwaltet es den in VHDL standardisierten Arbeitsbereich "work" (sieht der Nutzer in der Regel nicht).

-- Erste Instanz, hier ist die Verbindungsliste namentlich zugeordnet.
-- Diese Variante ist sicher gegen "Verzhlen" oder nachtrgliche nderungen bei der Deklaration des eingebundenen Moduls
Instanz1:	entity oder port map (b => x2, a => t1, y => y);

-- Zweite Instanz, hier ist die Verbindungsliste ber die Position zugeordnet
-- Das ist deutlich krzer, aber fehleranflliger
Instanz2:	entity und port map (x0, x1, t1);


end;
